//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpaceModuleSASLANON extends SpaceModuleThread {

//------------------------------------------------------------------------------
//  run
//------------------------------------------------------------------------------
public void run() {
     try {
          //--------------------------------------------------------------------
          //  see if channel start
          //--------------------------------------------------------------------
          if(isStart()) {
               //---------------------------------------------------------------
               //  get the authenticator
               //---------------------------------------------------------------
               String authenticator = InvisibleBase64.decode(request.getAuthenticator());

               if(authenticator.charAt(0) != 0) {
                    error(551);
                    return;
                    }

               authenticator = authenticator.substring(1);

               server.setAuthenticator(authenticator);

               //---------------------------------------------------------------
               //  set started
               //---------------------------------------------------------------
               start("<blob status='complete' />");
               return;
               }
  
          //--------------------------------------------------------------------
          //  unknown profile usage
          //--------------------------------------------------------------------
          error(550);
          }
     catch(SpaceTimeout e) {
          //--------------------------------------------------------------------
          //  timeout
          //--------------------------------------------------------------------
          fatal(e);
          } 
     catch(SpaceException e) {
          //--------------------------------------------------------------------
          //  exception
          //--------------------------------------------------------------------
          fatal(e);
          }
     }
}
