//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.StringBufferInputStream;
import java.io.IOException;

//OBSOLETE...3/20/2000...may need to revive parts to
//OBSOLETE...take email input from stdin

public class InvisibleEmailContentStream {

String                                   to;
String                                   from;
String                                   fromAddress;
String                                   fromUsername;
String                                   fromTemplate;
String                                   subject;
String                                   subjectTemplate;
String                                   subjectNoTemplate;
InvisibleDate                            date;
InvisibleDate                            received;
StringBuffer                             content;

//------------------------------------------------------------------------------
//  constructor
//------------------------------------------------------------------------------
public InvisibleEmailContentStream() {
     }

//------------------------------------------------------------------------------
//  set from standard input
//------------------------------------------------------------------------------
public void set() throws InvisibleDateException,IOException {
     set(System.in);
     }

//------------------------------------------------------------------------------
//  set from string
//------------------------------------------------------------------------------
public void set(String s)  throws InvisibleDateException,IOException {
     set(new StringBufferInputStream(s));
     }

//------------------------------------------------------------------------------
//  set from specified stream
//------------------------------------------------------------------------------
public void set(InputStream input)  throws InvisibleDateException,IOException {
     //-------------------------------------------------------------------------
     //  build stream
     //-------------------------------------------------------------------------
     BufferedReader in = new BufferedReader(new InputStreamReader(input));

     //-------------------------------------------------------------------------
     //  default is now
     //-------------------------------------------------------------------------
     content = new StringBuffer();

     boolean contentFound = false;
     String datestring = null;
     String receivedstring = null;
     String s;

     while((s = in.readLine()) != null) {
          //--------------------------------------------------------------------
          //  see if content start
          //--------------------------------------------------------------------
          if((!contentFound) && (s.length() == 0)) {
               contentFound = true;
               continue;
               }
 
          //--------------------------------------------------------------------
          //  see if content
          //--------------------------------------------------------------------
          if(contentFound) {
               content.append(s);
               content.append("\n");
               continue;
               }
 
          //--------------------------------------------------------------------
          //  see if subject
          //--------------------------------------------------------------------
          if(s.startsWith("Subject:")) {
               parseSubject(subject = extract(s));
               continue;
               }
 
          //--------------------------------------------------------------------
          //  see if to
          //--------------------------------------------------------------------
          if(s.startsWith("To:")) {
               to = extract(s);
               continue;
               }
 
          //--------------------------------------------------------------------
          //  see if from
          //--------------------------------------------------------------------
          if(s.startsWith("From:")) {
               parseFrom(from = extract(s));
               continue;
               }
 
          //--------------------------------------------------------------------
          //  see if date
          //--------------------------------------------------------------------
          if(s.startsWith("Date:")) {
               date = new InvisibleDate(s);
               }
 
          //--------------------------------------------------------------------
          //  see if date received
          //--------------------------------------------------------------------
          if(s.startsWith("Received:")) {
               received = new InvisibleDate(s);
               }
          }
     }

//------------------------------------------------------------------------------
//  parse subject
//------------------------------------------------------------------------------
public void parseSubject(String subject) {
     int index = subject.indexOf(":");
     if(index != -1) {
          try {
               subjectTemplate = subject.substring(0,index).trim();
               subjectNoTemplate = subject.substring(++index).trim();
               }
          catch(StringIndexOutOfBoundsException e) {
               subjectNoTemplate = "";
               }
          }
     else {
          subjectTemplate = "";
          subjectNoTemplate = subject;
          }
     }

//------------------------------------------------------------------------------
//  parse from
//------------------------------------------------------------------------------
public void parseFrom(String from) {
     InvisibleVector v = InvisibleUtil.parse(from,"<>\"' \t\n\r:!$^&*()/,");

     int size = v.size();

     for(int k=0;k<v.size();++k) {
          String fromTemp = v.getString(k);
          int index;
          if((index = fromTemp.indexOf("@")) != -1) {
               fromAddress = fromTemp;
               fromUsername = fromAddress.substring(0,index);

               if((index = fromUsername.indexOf("+")) != -1) {
                    try {
                         fromTemplate = fromUsername.substring(index+1);
                         fromUsername = fromUsername.substring(0,index);
                         }
                    catch(StringIndexOutOfBoundsException e) {
                         fromTemplate = "";
                         }
                    }
               else {
                    fromTemplate = "";
                    }

               break;
               }
          }
     }

//------------------------------------------------------------------------------
//  extract content from the email header element
//------------------------------------------------------------------------------
static private String extract(String s) {
     try {
          int index = s.indexOf(":");
          if(index == -1) return(s);
          return(s.substring(++index).trim());
          }
     catch(StringIndexOutOfBoundsException e) {
          return("");
          }
     }

//------------------------------------------------------------------------------
//  set and parse methods
//------------------------------------------------------------------------------
public void setSubject(String value) {
     subject = value;
     parseSubject(subject);
     }

public void setFrom(String value) {
     from = value;
     parseFrom(from);
     }

//------------------------------------------------------------------------------
//  bean property access methods
//------------------------------------------------------------------------------
public void setTo(String value) { to = value; }

public String getTo() { return(to); }
public String getFrom() { return(from); }
public String getFromAddress() { return(fromAddress); }
public String getFromUsername() { return(fromUsername); }
public String getFromTemplate() { return(fromTemplate); }
public String getSubject() { return(subject); }
public String getSubjectTemplate() { return(subjectTemplate); }
public String getSubjectNoTemplate() { return(subjectNoTemplate); }
public InvisibleDate getDate() { return(date); }
public InvisibleDate getReceived() { return(received); }
public String getContent() { return(content.toString()); }
}
