//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
import java.util.Properties;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class InvisibleProperties extends Properties {

//------------------------------------------------------------------------------
//  constructor
//------------------------------------------------------------------------------
public InvisibleProperties() {
     super();
     }

//------------------------------------------------------------------------------
//  load a properties file
//------------------------------------------------------------------------------
public void load(String pathname) throws InvisibleException {
     try {
          //--------------------------------------------------------------------
          //  get the input stream for the properties file
          //--------------------------------------------------------------------
          FileInputStream f = new FileInputStream(pathname);

          //--------------------------------------------------------------------
          //  load the properties
          //--------------------------------------------------------------------
          load(f);
          }
     catch(FileNotFoundException e) {
          throw new InvisibleException("InvisibleProperties: Missing Properties File: " + pathname);
          }
     catch(IOException e) {
          throw new InvisibleException("InvisibleProperties: " + e.toString());
          }
     }

//------------------------------------------------------------------------------
//  store a properties file
//------------------------------------------------------------------------------
public void store(String pathname,String header) throws InvisibleException {
     try {
          //--------------------------------------------------------------------
          //  get the output stream for the properties file
          //--------------------------------------------------------------------
          FileOutputStream f = new FileOutputStream(pathname);

          //--------------------------------------------------------------------
          //  store the properties
          //--------------------------------------------------------------------
          store(f,header);
          }
     catch(IOException e) {
          throw new InvisibleException("InvisibleProperties: " + e.toString());
          }
     }

//------------------------------------------------------------------------------
//  get an name
//------------------------------------------------------------------------------
public String get(String name) {
     return(getProperty(name));
     }

//------------------------------------------------------------------------------
//  set an name
//------------------------------------------------------------------------------
public void set(String name,String value) {
     put(name,value);
     }
}
