//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpacePingMulti {

//------------------------------------------------------------------------------
//  main
//------------------------------------------------------------------------------
public static void main(String[] argv) {
     SpaceServer server = null;

     try {
          //--------------------------------------------------------------------
          //  parse the command line
          //--------------------------------------------------------------------
          String host = null;
          int port = SpaceServer.defaultPort;
 
          for(int k=0;k<argv.length;++k) {
               //---------------------------------------------------------------
               //  -portno
               //---------------------------------------------------------------
               if(argv[k].equalsIgnoreCase("-portno")) {
                    port = InvisibleUtil.parseInt(argv[++k]);
                    continue;
                    }
 
               //---------------------------------------------------------------
               //  host
               //---------------------------------------------------------------
               host = argv[k];
               } 
 
          //--------------------------------------------------------------------
          //  instantiate the blocks server
          //--------------------------------------------------------------------
          server = new SpaceServer(host,port);

          server.setTrace(true);
          server.setDebug(true);

          //--------------------------------------------------------------------
          //  connect to blocks server
          //--------------------------------------------------------------------
          SpaceResponse greeting = server.connect(true);

          server.free(greeting);

          //--------------------------------------------------------------------
          //  start an echo channel
          //--------------------------------------------------------------------
          int count = 10;

          SpaceChannel channel = server.getChannel(SpaceProfile.nullEcho);
          SpaceResponse echoStart = server.start(channel,true);
          SpaceResponse echoResponse[] = new SpaceResponse[count];

          for(int k=0;k<count;++k) {
               //---------------------------------------------------------------
               //  ping multiple times on the channel without wait
               //---------------------------------------------------------------
               echoResponse[k] = channel.request("Ping",false);
               }

          for(int k=0;k<count;++k) {
               //---------------------------------------------------------------
               //  ping multiple times on the channel without wait
               //---------------------------------------------------------------
               echoResponse[k] = channel.wait(echoResponse[k]);
               }
          }
     catch(NullPointerException e) {
          System.err.println("java SpacePing [-portno port] host");
          }
     catch(SpaceTimeout e) {
          System.err.println(e.toString());
          }
     catch(SpaceException e) {
          System.err.println(e.toString());
          }
     finally {
          //--------------------------------------------------------------------
          //  close the connection
          //--------------------------------------------------------------------
          if(server != null) {
               server.close();
               }
          }
     }
}
