//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.ServletException;
import javax.servlet.ServletConfig;

import java.io.InputStream;
import java.io.IOException;
import java.util.Hashtable;
import org.apache.xerces.parsers.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.DocumentImpl;
import org.apache.xerces.dom.ElementImpl;
import org.apache.xerces.dom.NamedNodeMapImpl;
import org.xml.sax.InputSource;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class SpaceServlet extends InvisibleServlet {

SpaceServer                     server;
SpaceChannel                    channel;

//------------------------------------------------------------------------------
//  constructor
//------------------------------------------------------------------------------
public SpaceServlet() {
     super();
     }

//------------------------------------------------------------------------------
//  init
//------------------------------------------------------------------------------
public void init(ServletConfig config) throws ServletException {
     super.init(config);

     server = null;
     }

//------------------------------------------------------------------------------
//  get method
//------------------------------------------------------------------------------
protected void doGet(HttpServletRequest request,HttpServletResponse res) throws ServletException,IOException {
     doService(request,res);
     }

//------------------------------------------------------------------------------
//  post method
//------------------------------------------------------------------------------
protected void doPost(HttpServletRequest request,HttpServletResponse res) throws ServletException,IOException {
     doService(request,res);
     }

//------------------------------------------------------------------------------
//  service method to overload
//------------------------------------------------------------------------------
protected void doService(HttpServletRequest request,HttpServletResponse res) throws ServletException,IOException {
     InvisiblePage page = new InvisiblePage(res);

     try {
          //--------------------------------------------------------------------
          //  see if servlet needs bxxd connection
          //--------------------------------------------------------------------
          if(server == null) {
               //---------------------------------------------------------------
               //  instantiate the blocks server
               //---------------------------------------------------------------
               server = new SpaceServer("rwcsqa01.not.invisible.net");

               //---------------------------------------------------------------
               //  connect to blocks server
               //---------------------------------------------------------------
               SpaceResponse greetingResponse = server.connect(true);

               //---------------------------------------------------------------
               //  start a channel
               //---------------------------------------------------------------
               channel = server.getChannel(SpaceProfile.sep);
               SpaceResponse startResponse = server.start(channel,false);
               startResponse = channel.wait(startResponse);
               }

          //--------------------------------------------------------------------
          //  fetch
          //--------------------------------------------------------------------
          StringBuffer fetch = new StringBuffer();
          fetch.append("<fetch>\r\n");
          fetch.append("<union>\r\n");
          fetch.append("<intersect>\r\n");
          fetch.append("<compare subtree='doc.rfc' operator='contains' caseSensitive='false'>\r\n");
          fetch.append("<path><element property='email' /></path>\r\n");
          //fetch.append("<value>kzm@</value>\r\n");
          fetch.append("<value>mrose@</value>\r\n");
          fetch.append("</compare>\r\n");
          fetch.append("</intersect>\r\n");
          fetch.append("</union>\r\n");
          fetch.append("</fetch>\r\n");

          SpaceResponse response = channel.request(fetch.toString(),true);

          //--------------------------------------------------------------------
          //  parse the response
          //--------------------------------------------------------------------
          InputStream in = response.getInputStream();

          int size =  in.available();

          DOMParser parser = new DOMParser();
          parser.setFeature("http://apache.org/xml/features/dom/defer-node-expansion", true);
          parser.setFeature("http://apache.org/xml/features/continue-after-fatal-error", true);
          parser.parse(new InputSource(in));
          DocumentImpl document = (DocumentImpl)parser.getDocument();
 
          //--------------------------------------------------------------------
          //  show
          //--------------------------------------------------------------------
          Element root = document.getDocumentElement();
          NodeList list = root.getElementsByTagName("answers");

          page.println("\nApache-Xerces Parsing Results<br><blockquote>");
          page.println("<pre>");
          page.println("XML Stream Size: " + size + " Bytes");
          page.println("XML Root Element Name: " + root.getTagName());
          page.println("XML Root Children Count: " + list.getLength());
          page.println("</blockquote>");
          page.println(InvisibleUtil.serp(response.toString(),"<","&lt;"));
          page.println("</pre>");
          }
     catch(SpaceTimeout e) {
          System.err.println(getStackTrace(e));
          }
     catch(SpaceException e) {
          System.err.println(getStackTrace(e));
          }
     catch(org.xml.sax.SAXException e) {
          System.err.println(getStackTrace(e));
          }
     catch(IOException e) {
          System.err.println(getStackTrace(e));
          }
     }
}
