//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpaceChannelCache extends InvisibleHashtable {

//------------------------------------------------------------------------------
//  constructor
//------------------------------------------------------------------------------
public SpaceChannelCache() {
     super();
     }

//------------------------------------------------------------------------------
//  set a new channel
//------------------------------------------------------------------------------
public SpaceChannel set(int channel,String profile) throws SpaceException {
     //-------------------------------------------------------------------------
     //  make sure the channel does not already exist
     //-------------------------------------------------------------------------
     if(get(channel) != null) {
          throw new SpaceException("SpaceChannelCache: Channel Already Started: " + channel);
          }

     //-------------------------------------------------------------------------
     //  make the new channel
     //-------------------------------------------------------------------------
     SpaceChannel channelElement = new SpaceChannel(channel);

     channelElement.setProfile(profile);

     //-------------------------------------------------------------------------
     //  set
     //-------------------------------------------------------------------------
     set(channel,channelElement);

     return(channelElement);
     }

//------------------------------------------------------------------------------
//  set a channel
//------------------------------------------------------------------------------
public void set(int channel,SpaceChannel channelElement) {
     //-------------------------------------------------------------------------
     //  convert channel to string for hashtable
     //-------------------------------------------------------------------------
     String channelKey = String.valueOf(channel);

     //-------------------------------------------------------------------------
     //  set
     //-------------------------------------------------------------------------
     super.set(channelKey,channelElement);
     }

//------------------------------------------------------------------------------
//  get a channel
//------------------------------------------------------------------------------
public SpaceChannel get(int channel) {
     //-------------------------------------------------------------------------
     //  convert channel to string for hashtable
     //-------------------------------------------------------------------------
     String channelKey = String.valueOf(channel);

     //-------------------------------------------------------------------------
     //  see if channel already exists
     //-------------------------------------------------------------------------
     SpaceChannel channelElement;

     if((channelElement = (SpaceChannel)(super.get(channelKey))) != null) {
          //--------------------------------------------------------------------
          //  channel found
          //--------------------------------------------------------------------
          return(channelElement);
          }

     //-------------------------------------------------------------------------
     //  channel not found
     //-------------------------------------------------------------------------
     return(channelElement);
     }
}
