//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpaceConfig {
 
InvisibleHashtable                      parameter;
InvisibleHashtable                      profile;

//------------------------------------------------------------------------------
//  constructor
//------------------------------------------------------------------------------
public SpaceConfig() {
     parameter = new InvisibleHashtable();
     profile = new InvisibleHashtable();
     }

//------------------------------------------------------------------------------
//  get/create a profile
//------------------------------------------------------------------------------
public SpaceProfile getProfile(String uri) {
     if(uri == null) return(null);

     SpaceProfile p = (SpaceProfile)(profile.get(uri));

     if(p == null) {
          p = new SpaceProfile(uri);
          profile.set(uri,p);
          }

     return(p);
     }

//------------------------------------------------------------------------------
//  set a parameter
//------------------------------------------------------------------------------
public void set(String key,String value) {
     parameter.set(key,value);
     }

//------------------------------------------------------------------------------
//  get a parameter
//------------------------------------------------------------------------------
public String get(String key) {
     return((String)(parameter.get(key)));
     }

//------------------------------------------------------------------------------
//  get greeting from loaded profiles
//------------------------------------------------------------------------------
public String getGreeting() {
     StringBuffer sb = new StringBuffer();
     sb.append("<greeting localize='");

     String localize = get("localize");
     if((localize == null) || (localize.length() == 0)) {
          sb.append("en-us");
          }
     else {
          sb.append(" ");
          sb.append(localize);
          }
     sb.append("'>");

     InvisibleVector v = profile.getKeys();

     int size = v.size();

     for(int k=0;k<size;++k) {
          sb.append("<profile uri='");
          sb.append((String)(v.get(k)));
          sb.append("' />");
          }

     sb.append("</greeting>");

     return(sb.toString());
     }
}
