//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
import java.util.StringTokenizer;
import java.util.NoSuchElementException;

public class SpaceHeader {

private String                          type;
private String                          more;
private int                             serial;
private long                            seqno;
private int                             size;
//private String                          status;

//------------------------------------------------------------------------------
//  constuctor
//------------------------------------------------------------------------------
public SpaceHeader(String s) {
     }

//------------------------------------------------------------------------------
//  parse
//------------------------------------------------------------------------------
public String parse(String s,String headerType) throws SpaceException {
     //-------------------------------------------------------------------------
     //  parse header
     //-------------------------------------------------------------------------
     StringTokenizer parse = new StringTokenizer(s," ");

     try {
          type = parse.nextToken();
          if(!(type.equals(headerType))) {
               throw new SpaceException("SpaceHeader: Expecting Header: " + s);
               }
          more = parse.nextToken();
          serial = InvisibleUtil.parseInt(parse.nextToken());
          seqno = InvisibleUtil.parseLong(parse.nextToken());
          size = InvisibleUtil.parseInt(parse.nextToken());
          return(parse.nextToken());
          }
     catch(NoSuchElementException e) {
          throw new SpaceException("SpaceHeader: Poorly Formed Header: " + s);
          }
     }

//------------------------------------------------------------------------------
//  header types
//------------------------------------------------------------------------------
public boolean isResponse() { return(type.equals("RSP")); }
public boolean isRequest() { return(type.equals("REQ")); }

//------------------------------------------------------------------------------
//  more
//------------------------------------------------------------------------------
public boolean isComplete() { return(more.equals(".")); }
public boolean isIncomplete() { return(more.equals("*")); }

//------------------------------------------------------------------------------
//  status
//------------------------------------------------------------------------------
public boolean isError() {
     return(false);
     }

//------------------------------------------------------------------------------
//  bean property access methods
//------------------------------------------------------------------------------
public String getMore() { return(more); }
public int getSerial() { return(serial); }
public long getSeqno() { return(seqno); }
public int getSize() { return(size); }
}
