//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpaceProfile {

public final static String              sep = "http://xml.resource.org/profiles/SEP";
public final static String              tls = "http://xml.resource.org/profiles/TLS";
public final static String              saslAnonymous = "http://xml.resource.org/profiles/sasl/ANONYMOUS";
public final static String              saslOtp = "http://xml.resource.org/profiles/sasl/OTP";
public final static String              saslExternal = "http://xml.resource.org/profiles/sasl/EXTERNAL";
public final static String              nullEcho = "http://xml.resource.org/profiles/NULL/ECHO";
public final static String              nullSink = "http://xml.resource.org/profiles/NULL/SINK";

String                                  uri;
InvisibleHashtable                      parameter;

//------------------------------------------------------------------------------
//  constructor
//------------------------------------------------------------------------------
public SpaceProfile(String uriArg) {
     uri = uriArg;
     }

//------------------------------------------------------------------------------
//  set a parameter
//------------------------------------------------------------------------------
public void set(String key,String value) {
     if(parameter == null) parameter = new InvisibleHashtable();
     parameter.set(key,value);
     }   

//------------------------------------------------------------------------------
//  get a parameter
//------------------------------------------------------------------------------
public String get(String key) {
     if(parameter == null) return(null);
     return((String)(parameter.get(key)));
     }

//------------------------------------------------------------------------------
//  bean property access methods
//------------------------------------------------------------------------------
public String getUri() { return(uri); }
}
