//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpaceSep {

//------------------------------------------------------------------------------
//  fetch
//------------------------------------------------------------------------------
static public String fetch(String name) {
     return(fetch(name,null));
     }

//------------------------------------------------------------------------------
//  fetch
//------------------------------------------------------------------------------
static public String fetch(String name,String element) {
     StringBuffer sb = new StringBuffer();

     sb.append("<fetch>");
     sb.append("<union><intersect>");
     sb.append("<compare subtree='");
     sb.append(name);
     sb.append("'>");
     sb.append("<path attribute='name'>");
     if((element != null) && (element.length() > 0)) {
          sb.append("<element property='");
          sb.append(element);
          sb.append("' />");
          }
     sb.append("</path>");
     sb.append("<value>");
     sb.append(name);
     sb.append("</value>");
     sb.append("</compare>");
     sb.append("</intersect></union>");
     sb.append("</fetch>");

     return(sb.toString());
     }

//------------------------------------------------------------------------------
//  lock
//------------------------------------------------------------------------------
static public String lock(String subtree) throws SpaceException {
     if((subtree == null) || (subtree.length() == 0)) {
          throw new SpaceException("SpaceSep: Lock Requires subtree");
          }

     StringBuffer sb = new StringBuffer();
     sb.append("<lock subtree='");
     sb.append(subtree);
     sb.append("'></lock>");

     return(sb.toString());
     }

//------------------------------------------------------------------------------
//  store
//------------------------------------------------------------------------------
static public String store(String name,String action,String serial,String block) throws SpaceException {
     if((name == null) || (name.length() == 0)) {
          throw new SpaceException("SpaceSep: Store Requires Block Name");
          }

     if((action == null) || (action.length() == 0)) {
          throw new SpaceException("SpaceSep: Store Requires Action");
          }

     if((serial == null) || (serial.length() == 0)) {
          throw new SpaceException("SpaceSep: Store Requires Serial");
          }

     StringBuffer sb = new StringBuffer();
     sb.append("<store action='");
     sb.append(action);
     sb.append("'>");

     sb.append("<block name='");
     sb.append(name);
     sb.append("' serial='");
     sb.append(serial);
     sb.append("'>");

     if(!(action.equalsIgnoreCase("delete"))) {
          if((block == null) || (block.length() == 0)) {
               throw new SpaceException("SpaceSep: Store Requires Block Content");
               }

          sb.append(block);
          }

     sb.append("</block>");
     sb.append("</store>");

     return(sb.toString());
     }

//------------------------------------------------------------------------------
//  release with default action
//------------------------------------------------------------------------------
static public String release(int prevno) throws SpaceException {
     return(release(prevno,null));
     }

//------------------------------------------------------------------------------
//  release
//------------------------------------------------------------------------------
static public String release(int prevno,String action) throws SpaceException {
     if(prevno == -1) {
          throw new SpaceException("SpaceSep: Release Requires prevno");
          }

     StringBuffer sb = new StringBuffer();
     sb.append("<release prevno='");
     sb.append(String.valueOf(prevno));
     sb.append("'");
     if((action != null) && (action.length() > 0)) {
          sb.append(" action='");
          sb.append(action);
          sb.append("'");
          }
     sb.append("></release>");

     return(sb.toString());
     }
}
