//------------------------------------------------------------------------------
//  Copyright (c) 2000, Invisible Worlds, Inc. All rights reserved.
// 
//  The contents of this file are subject to the Blocks Public License (the 
//  "License"); you may not use this file except in compliance with the License.  
//  You may obtain a copy of the License at http://www.invisible.net/ 
// 
//  Software distributed under the License is distributed on an "AS IS" basis,  
//  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for  
//  the specific language governing rights and limitations under the License. 
//------------------------------------------------------------------------------
public class SpaceKeyOtp {

//------------------------------------------------------------------------------
//  main
//------------------------------------------------------------------------------
public static void main(String[] argv) {
     try {
          //--------------------------------------------------------------------
          //  get args
          //--------------------------------------------------------------------
          String algorithm = argv[0];
          String phrase = argv[1];
          String seed = argv[2];
          int count = InvisibleUtil.parseInt(argv[3]);

          //--------------------------------------------------------------------
          //  pass phrase must be at least 10 characters
          //--------------------------------------------------------------------
          if(phrase.length() < 10) {
               System.err.println("Pass Phrase Must Be At Least 10 Characters");
               return;
               }

          //--------------------------------------------------------------------
          //  count must be numeric and more than zero
          //--------------------------------------------------------------------
          if(count <= 0) {
               System.err.println("Count Must Be > 1 And Numeric");
               return;
               }

          //--------------------------------------------------------------------
          //  get hex key
          //--------------------------------------------------------------------
          InvisibleOtp otp = new InvisibleOtp(algorithm,phrase,seed,count);

          String key = otp.get("hex");

          System.out.println(key.substring(4));
          }
     catch(InvisibleException e) {
          System.err.println(e.toString());
          }
     catch(ArrayIndexOutOfBoundsException e) {
          System.err.println("usage: java SpaceKeyOtp algorithm passphrase seed count");
          }
     }
}
